\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{sw-latex-template/doi}[2005/03/24 handle doi numbers]

%% $Id: doi.sty,v 1.2 2005/05/26 12:29:28 msneep Exp $

%\RequirePackage{hyperref}  %Commented out as is loaded in tropsw.cls, loading order with hyperref gives problems.

\newcommand*{\doi}{% 
   \begingroup 
      \lccode`\~=`\#\relax 
      \lowercase{% 
         \def~{\#}% 
      }% 
      \lccode`\~=`\<\relax 
      \lowercase{% 
         \def~{\textless}% 
      }% 
      \lccode`\~=`\>\relax 
      \lowercase{% 
         \def~{\textgreater}% 
      }% 
      \lccode`\~=0\relax 
      \catcode`\#=\active 
      \catcode`\<=\active 
      \catcode`\>=\active 
      \@doi
}% 

\def\@doi#1{% 
   \let\#\relax 
   \let\textless\relax 
   \let\textgreater\relax 
   \edef\x{% 
      \toks0={{#1}}% 
   }% 
   \x
   \edef\#{\@percentchar23}% 
   \edef\textless{\string<}% 
   \edef\textgreater{\string>}% 
   \edef\x{% 
      \toks1={\noexpand\href{http://dx.doi.org/#1}}% 
   }% 
   \x
   \edef\x{% 
      \endgroup 
      \the\toks1 \the\toks0 % 
   }% 
   \x
}
